#ifndef __TIMER_C
#define __TIMER_C
#include "main.h"

//###################################################################################
//Nicht sonderlich genau !!
void Delay1ms(unsigned int time)
//###################################################################################
{
 unsigned int i;

 for(i=0; i<time; i++) Delay100us(10);
}

//###################################################################################
//Nicht sonderlich genau !!
//time<=255 !!
void Delay100us(unsigned char time)
//###################################################################################
{
 unsigned char k,l;

 for(k=0; k<time; k++)
  {
  //Mit dieser Schleife wird NOP(); 10 x sysclk ausgefhrt
   for(l=0; l<(sysclk_s*5); l++)
    {
     NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP();  
     NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    }
  }
}

void init_timer_16(unsigned int prescaler, unsigned int comparevalue) 
{
	TCNT1H = 0;
	TCNT1L = 0;
    TCCR1A = 0;//kein Outputsignal,kein PWM
	if (prescaler==8){
		TCCR1B = 1<<CS11;
	}
	else if (prescaler==1024){
		TCCR1B = (1<<CS12)|(1<<CS10);
	}
	//OCR1A = comparevalue;
	OCR1AH = (unsigned char)(comparevalue>>8);
	OCR1AL = (unsigned char)comparevalue;
}

void stop_timer_16()
{
	TCCR1B = 0;
	TCNT1 = 0;
}

void init_timer_8_2(void) 
{
	TCNT2 = 0;
	TCCR2 = (1<<CS22)|(1<<CS21)|(1<<CS20);//CPU-Takt/1024
}

void stop_timer_8_2(void)
{
	TCCR2 = 0;
}

ISR(TIMER2_COMP_vect)
{
	//Zurcksetzen des Timers auf 0
	TCNT2 = 0;
	
	if (Clock_Syckle){
		Clock_Syckle = 0;
		
		if (Status->EngineDirection[0]!=0){
			Engine_PORT |= (1<<CLK_0);
		}
		if (Status->EngineDirection[1]!=0){
			Engine_PORT |= (1<<CLK_1);
		}		
	}
	else{
		Clock_Syckle = 1;
		
		unsigned char a=0;
		
		Motorlogik();
		
		for (a=0;a<2;a++){
		
			if (Status->EngineDirection[a]==1){
				if (a==0){
					Engine_PORT &= ~((1<<DIR_0)|(1<<CLK_0));
				}
				else{
					Engine_PORT &= ~((1<<DIR_1)|(1<<CLK_1));
				}				
				Status->Position[a] += 1;
			}
			else if (Status->EngineDirection[a]==2){
				if (a==0){
					Engine_PORT |= 1<<DIR_0;
					Engine_PORT &= ~(1<<CLK_0);
				}
				else{
					Engine_PORT |= 1<<DIR_1;
					Engine_PORT &= ~(1<<CLK_1);
				}
				Status->Position[a] -= 1;
			}
		}
	}
}

//Servosignalerzeugung 
ISR(TIMER1_COMPA_vect)
{
	if (Servostatus==0){
		if (p_Adj->Potimode){
			Status->Position[2] = ADCMeasure(POTI);
		}
		else{
			Status->Position[2] = Servowert;
		}
		ServoLogigk();
		Servostatus = 1;
	}
	else{
		init_timer_16(1024,SERVO_TAKT_FREQUENZ);
		CONTROL_PORT &= ~(1<<SERVO); //Motorpin aus
		Servostatus = 0;
	}
}

#endif
