#ifndef DISPLAY_H
#define DISPLAY_H

#define BACKLIGHT_P PORTA
#define BACKLIGHT_P_INI DDRA
#define BACKLIGHT_PIN 2

#define CPU_SPEED_MHZ 16
#define DI_PORT PORTB
#define DI_PORT_INI DDRB
#define DI_PORT_INP PINB

#define DIADJUSTCONST 8
#define DISPLAY_ON 4
#define CURSOR_ON 2
#define BLINKING_ON 1

#define D7 0
#define D6 1
#define D5 2
#define D4 3
#define E 4
#define RW 5
#define RS 6
#define BEFEHLSAUSFUEHRZEIT 4

#define D_ZEILEN_CNT 1
#define D_SPALTEN_CNT 20
#define D_Z1_ADDR 0
#define D_Z2_ADDR 64
#define D_Z3_ADDR 22
#define D_Z4_ADDR 86

#define D_SET_POSITION_ADDR 128
#define D_SET_SONDERZEICHEN_ADDR 64

extern void Schreibe_Sonderzeichen(unsigned char *data, unsigned char pos);
extern unsigned char ConvertDData(unsigned char data);
extern void WaitD(void);
extern void DisplaySendData(unsigned char data);
extern void DText(unsigned char *Text);
extern void init_display(void);
extern void D_Add_Char(unsigned char c);
extern void Setze_Aktuelle_Position(void);
extern void Setzte_Position(unsigned char x, unsigned char y);
extern void trigger_EN(void);
extern void D_Check_Boundarys(unsigned char Pos_changed);
extern void Set_Adjustments(unsigned char Position, unsigned char value);


struct Display{
	volatile unsigned char Spalten_Pos;
	volatile unsigned char Zeilen_Pos;	
	unsigned char Adjustment;
};

extern struct Display D1;

#endif 
