#ifndef _main_h_
#define _main_h_

#include <stdio.h>
#include <avr/io.h>	
#include <ctype.h>
#include <avr\pgmspace.h>
#include <avr/eeprom.h>	
#include <avr/interrupt.h>
#include <string.h>
#include <stdlib.h>
#include <compat/deprecated.h> //sbi und cbi kompatibilitt
	
#include "timer.h"
#include "display.h"
#include "bohrer.h"

#define USR UCSRA
#define UCR UCSRB
#define UBRR UBRRL
#define EICR EICRB


//#define sysclk	14238281 //Quarz Frequenz in Hz
//#define sysclk	7372800	
#define sysclk	16000000	
#define sysclk_s (sysclk/1000000) //Frequenz in MHZ

//Die Baud_Rate der Seriellen Schnittstelle ist 9600 Baud
//#define baud_rate 9600		//Baud Rate fr die Serielle Schnittstelle	
#define baud_rate 38400


extern void IOInit (void);
extern int uart_putchar (char c,FILE *file);
extern int main (void);


#define NOP() asm volatile ("nop" ::)


#endif//_main_h_
